// ProcuraEngine.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <time.h>

#include "Estacoes.h"

#define _ALL 1
//#define _COPYPASTE 1

int main(int argc, char* argv[])
{
	char str[256];
	clock_t instante;
	int resultado;
	CEstacao estacoes;
	TProcuraMelhorativa::maximoAvaliacoes = 100000;
	TProcuraConstrutiva::calcularCaminho = false;

	for (int i = 13; i < 14; i++) {
		estacoes.CarregarInstancia(i);

		TRand::srand(20);

#ifndef _ALL
		sprintf_s(str, "Territorio %d", i + 1);
		estacoes.TesteManual(str, 20);
#else
		printf("\n\nID%d: ", i + 1);

		if(false && i<17) {	// MP - Melhor Primeiro
			instante = clock();
			estacoes.LimparEstatisticas();
			estacoes.SolucaoVazia();
			estacoes.MelhorPrimeiro(1000);
			if(TProcuraConstrutiva::solucao!=NULL)
				resultado=((TProcuraMelhorativa*)TProcuraConstrutiva::solucao)->Avaliar();
#ifdef _COPYPASTE
			printf("\n%d\n%d\n%d\n%.3f",
				estacoes.geracoes,
				estacoes.avaliacoes,
				resultado,
				1.0 * (clock() - instante) / CLOCKS_PER_SEC);
#else
			printf("\n- MP         : \t%6d %6d %6d (%.3fs msec)",
				estacoes.geracoes,
				estacoes.avaliacoes,
				resultado,
				1.0 * (clock() - instante) / CLOCKS_PER_SEC);
#endif
			//TProcuraConstrutiva::solucao->Debug();
			TProcuraConstrutiva::solucao = NULL;
		}

		if(false)  {	// AStar - A * limitado(no timo)
			instante = clock();
			estacoes.LimparEstatisticas();
			estacoes.SolucaoVazia();
			estacoes.AStar(1000);
			if (TProcuraConstrutiva::solucao != NULL)
				resultado = ((TProcuraMelhorativa*)TProcuraConstrutiva::solucao)->Avaliar();
#ifdef _COPYPASTE
			printf("\n%d\n%d\n%d\n%.3f",
				estacoes.geracoes,
				estacoes.avaliacoes,
				resultado,
				1.0 * (clock() - instante) / CLOCKS_PER_SEC);
#else
			printf("\n- AStar(1000): \t%6d %6d %6d (%.3fs msec)",
				estacoes.geracoes,
				estacoes.avaliacoes,
				resultado,
				1.0 * (clock() - instante) / CLOCKS_PER_SEC);
#endif
			TProcuraConstrutiva::solucao = NULL;
		}

		{	// EMm - Escalada do Monte(melhor)
			instante = clock();
			estacoes.LimparEstatisticas();
			estacoes.NovaSolucao();
			resultado = estacoes.EscaladaDoMonte(false);
#ifdef _COPYPASTE
			printf("\n%d\n%d\n%d\n%.3f",
				estacoes.geracoes,
				estacoes.avaliacoes,
				resultado,
				1.0 * (clock() - instante) / CLOCKS_PER_SEC);
#else
			printf("\n- EMm        : \t%6d %6d %6d (%.3fs msec)",
				estacoes.geracoes,
				estacoes.avaliacoes,
				resultado,
				1.0 * (clock() - instante) / CLOCKS_PER_SEC);
#endif
			estacoes.custo = -1;
			estacoes.Avaliar();
			estacoes.Debug();
		}

		{	// EMm - Escalada do Monte(primeiro)
			instante = clock();
			estacoes.LimparEstatisticas();
			estacoes.NovaSolucao();
			resultado = estacoes.EscaladaDoMonte(true);
#ifdef _COPYPASTE
			printf("\n%d\n%d\n%d\n%.3f",
				estacoes.geracoes,
				estacoes.avaliacoes,
				resultado,
				1.0 * (clock() - instante) / CLOCKS_PER_SEC);
#else
			printf("\n- EMp        : \t%6d %6d %6d (%.3fs msec)",
				estacoes.geracoes,
				estacoes.avaliacoes,
				resultado,
				1.0 * (clock() - instante) / CLOCKS_PER_SEC);
#endif
		}

		{	// AG - Algoritmos Genticos
			instante = clock();
			estacoes.LimparEstatisticas();
			estacoes.NovaSolucao();
			resultado = estacoes.AlgoritmoGenetico(20,50,0);
#ifdef _COPYPASTE
			printf("\n%d\n%d\n%d\n%.3f",
				estacoes.geracoes,
				estacoes.avaliacoes,
				resultado,
				1.0 * (clock() - instante) / CLOCKS_PER_SEC);
#else
			printf("\n- AG(20,50,0): \t%6d %6d %6d (%.3fs msec)",
				estacoes.geracoes,
				estacoes.avaliacoes,
				resultado,
				1.0 * (clock() - instante) / CLOCKS_PER_SEC);
#endif
		}

		{	// AG - Algoritmos Genticos
			instante = clock();
			estacoes.LimparEstatisticas();
			estacoes.NovaSolucao();
			resultado = estacoes.AlgoritmoGenetico(100, 50, 10);
#ifdef _COPYPASTE
			printf("\n%d\n%d\n%d\n%.3f",
				estacoes.geracoes,
				estacoes.avaliacoes,
				resultado,
				1.0 * (clock() - instante) / CLOCKS_PER_SEC);
			estacoes.Debug();
#else
			printf("\n- AG(100,25,10):%6d %6d %6d (%.3fs msec)",
				estacoes.geracoes,
				estacoes.avaliacoes,
				resultado,
				1.0 * (clock() - instante) / CLOCKS_PER_SEC);
#endif
		}

#endif
	}
}
